	include	"tios.h"
	include	"userlib.h"
	xdef	_main
	xdef	_ti92plus
	xdef	_ti89

;-------------------------------------------------------------
; Program made with Fargo Program Editor v2.0
; Benoit SCHERRER - p.c.scherrer@wanadoo.fr
;-------------------------------------------------------------

;***************** Start of FARGO II Program ******************
_main:

	bra.s	get_handle
handle	dc.w	0

get_handle:
	move.w	handle(pc),d0

	lea	scan(pc),a5
	bsr	AffString

	move.w	#tios::FolderListHandle,d1
	DEREF	d1,a0

	move.l	(a0)+,d7
	subq.w	#1,d7

loop_folder:
	move.w	12(a0),d1
	DEREF	d1,a1

	move.l	(a1)+,d6
	subq.w	#1,d6

loop_var:
	cmp.w	12(a1),d0
	beq	found

	lea	14(a1),a1
	dbra	d6,loop_var

	lea	14(a0),a0
	dbra	d7,loop_folder

noprog:
	lea	not_found(pc),a5
	bsr	AffString

	jsr	userlib::idle_loop
	rts

found:
	lea	compiling(pc),a5
	bsr	AffString
	clr.b	d0
	move.l	tios::top_estack,a6
	bsr	push_d0
	lea	inc_str(pc),a2
	bsr	push_a0
	move.l	a0,a2
	bsr	push_a0
	move.b	#'\',d0
	bsr	push_d0
	move.l	a1,a2
	bsr	push_a0
	clr.b	d0
	bsr	push_d0
	move.b	#$2D,d0
	bsr	push_d0

	lea	buf(pc),a2
loop_get_rep_null:
	move.b	(a0)+,(a2)+
	bne	loop_get_rep_null
	subq.l	#1,a2

	clr.w	-(a7)
	move.l	a2,-(a7)
	jsr	tios::FolderCur
	addq.l	#6,a7
	tst.b	d0
	beq	noprog

	clr.w	-(a7)
	pea	as92_end_str(pc)
	jsr	tios::SymFindPtr
	addq.l	#6,a7

	move.l	a0,d0
	beq	noprog

	move.l	a6,tios::top_estack

	move.w	12(a0),d0
	move.l	a6,-(a7)
	move.w	d0,-(a7)
	jsr	userlib::exec
	addq.l	#2,a7
	move.l	(a7)+,a6
	move.l	tios::top_estack,a5
	cmp.l	a5,a6
	bne	affst

	clr.w	-(a7)
	pea	as92ret_end_str(pc)
	jsr	tios::SymFindPtr
	addq.l	#6,a7

	move.l	a0,d0
	beq	noprog

	move.w	12(a0),d0
	move.w	d0,-(a7)
	jsr	tios::HToESI
	addq.l	#2,a7

	move.l	a0,a5

affst:
	cmp.b	#$1F,(a5)
	beq	aff_succ
	move.l	#$10001,-(a7)
	move.l	a5,-(a7)
	jsr	tios::display_statements
	addq.l	#8,a7
	move.w	d0,d7
	DEREF	d0,a0
	move.l	a0,a5

	clr.w	d6
loop_pause:
	bsr	AffString
pause_loop:
	jsr	userlib::idle_loop
	cmp.w	#$D,d0
	beq	sortie_succ
	cmp.w	#$108,d0
	beq	sortie_succ
	cmp.w	#KEY_RIGHT,d0
	beq	key_right
	cmp.w	#KEY_LEFT,d0
	beq	key_left
	bra	pause_loop

key_right:
	cmp.w	#6,d6
	beq	pause_loop
	addq.w	#1,d6
	add.l	#10,a5
	bra	loop_pause

key_left:
	tst.w	d6
	beq	pause_loop
	subq.w	#1,d6
	sub.l	#10,a5
	bra	loop_pause

sortie_succ:
	move.w	d7,-(a7)
	jsr	tios::HeapFree
	addq.l	#2,a7
	rts

aff_succ:
	lea	success(pc),a5
	bsr	AffString
	jsr	userlib::idle_loop
	rts

AffString:
	movem.l d0-d7/a0-a6,-(a7)
	move.l	a5,-(a7)
	jsr	tios::ST_showHelp
	addq.l	#4,a7
	movem.l (a7)+,d0-d7/a0-a6
	rts

push_d0:
	addq.l	#1,a6
	move.b	d0,(a6)
sortie:
	rts

push_a0:
	move.b	(a2)+,d0
	beq	sortie
	bsr	push_d0
	bra	push_a0

;******************** Program Variables ***********************

inc_str	dc.b	"includ",101," ",0
as92		dc.b	"main\as92"
as92_end_str	dc.b	0
not_found	dc.b	"File or AS92 not found",0
scan		dc.b	"Scanning VAT...",0
compiling	dc.b	"Compiling with AS92...",0
success	dc.b	"File successfuly compiled!",0
seeas92ret	dc.b	"See AS92RET to see the conclusion!",0
as92ret	dc.b	"as92ret"
as92ret_end_str dc.b	0
buf		dcb.b	9,0

;********************** End of Program ************************
	end
